# coding: utf-8

module UzuUzu
  module Controller
    class Initialize
      def index
        self.send("step#{info.step}")
        case(info.step)
        when 1
          respond(render_page(info, render_file(__DIR__('view/initialize/step1.rhtml'))))
        when 2
          respond(render_page(info, render_file(__DIR__('view/initialize/step2.rhtml'))))
        end
      end # index

      private

      def step1
        if session[:openid_identity].nil?
          return
        end
        UzuUzu.transaction do |tr|
          tr.begin
          info.step = 2
          user = UzuUzu::User.new
          user.user_id = session[:openid_identity]
          user.domain = session[:openid_domain]
          user.name = 'admin'
          user.admin = true
          if info.save
            tr.commit
          else
            tr.rollback
          end
        end
      end # step1
      
      def step2
        if session[:openid_identity].nil?
          redirect rf(::UzuUzu::Controller::Index)
        end
        login_user = ::UzuUzu::User.first(:user_id => session[:openid_identity])
        login_user
      end # step2
    end # Initialize
  end # Controller
end # UzuUzu
