# coding: utf-8

module UzuUzu
  module Helper
    module Page
      def page
        @_page ||= controller.info
      end
      
      def contents(options={}, locals={})
        @_contents ||= page.contents_render(options, locals)
      end
      
      def render_page(page, contents=nil, options={}, locals={})
        @_page = page
        @_contents = contents
        body = page.render(options, locals)
        body = render_engine(body)
        @_page = nil
        @_contents = nil
        body
      end
      
      def render_plugin(page, body)
        ::UzuUzu::Plugin.render(page, body)
      end
      
      def page_title
        h page.page_title
      end
      
      def page_meta
        if page.respond_to?(:page_metas)
          page.page_metas.map do |meta|
            meta(meta.name, meta.content)
          end.join("\n")
        else
          meta("title", page_title)
        end
      end
      
      def page_js
        page.js_urls.map do |url|
          js(url)
        end.join("\n")
      end
      
      def page_css
        page.css_urls.map do |url|
          css(url)
        end.join("\n")
      end
      
      def breadcrumbs(sep)
        page.breadcrumbs.map do |breadcrumb|
          ""
        end.join("#{sep}\n")
      end
    end
  end
end