# coding: utf-8
require 'uzuuzu-cms/model/user'
require 'uzuuzu-cms/model/blog_category'
require 'uzuuzu-cms/model/blog_comment'
require 'uzuuzu-cms/model/blog_entry'

module UzuUzu
  class User
    has n, :blogs
    has n, :blog_comments
  end

  #
  #
  #
  class Blog
    include DataMapper::Resource

    property :id, Serial
    property :title, String,
              :required => true,
              :length => 255

    has n, :blog_entries
    has n, :blog_categories

    belongs_to :user
  end #Blog

  if auto_upgrade?
    repository do
      Blog.auto_upgrade!
      BlogCategory.auto_upgrade!
      BlogEntry.auto_upgrade!
      BlogComment.auto_upgrade!
      BlogCategoryBlogEntry.auto_upgrade!
    end
  end
end #UzuUzu

