# coding: utf-8
require 'uzuuzu-cms/model/css'
require 'uzuuzu-cms/model/javascript'

module UzuUzu
  class Css
    has n, :contents, 'UzuUzu::Contents', :through => Resource
  end

  class Javascript
    has n, :contents, 'UzuUzu::Contents', :through => Resource
  end

  class Contents
    include DataMapper::Resource
    include DataMapper::Timestamps

    property :id, Serial
    property :format, Enum[:none, :erb, :markdown],
              :required => true
    property :name, String,
              :required => true,
              :length => 255
    property :body, Text,
              :required => true
    timestamps :at

    has n, :csses, :through => Resource
    has n, :javascripts, :through => Resource
    
    def render(options={}, locals={})
      contents = "<div id=\"contents_#{self.id}\">\n"
      contents += UzuUzu::Controller.current.render_engine(self.body, self.format, options, locals)
      contents += "\n</div>"
    end
  end # Contents

  if auto_upgrade?
    repository do
      Contents.auto_upgrade!
      ContentsJavascript.auto_upgrade!
      ContentsCss.auto_upgrade!
    end
  end
end # UzuUzu
