# coding: utf-8
require 'uzuuzu-cms/model/user'

module UzuUzu
  class User
    has n, :images
  end

  class Image
    include DataMapper::Resource
    include DataMapper::Timestamps

    property :id, Serial
    property :file_name, String,
              :required => true,
              :unique => true,
              :length => 255
    property :content_type, String,
              :required => true,
              :length => 255
    timestamps :updated_at

    if UzuUzu.gae?
      property :image, Blob,
                :required => true,
                :length => 2 ** 32
    else
      property :image, Binary,
                :required => true,
                :length => 2 ** 32
    end

    belongs_to :user
  end #Image

  if auto_upgrade?
    repository do
      Image.auto_upgrade!
    end
  end
end #UzuUzu
