# coding: utf-8

module UzuUzu

  class Css
    has n, :layouts, :through => Resource
  end

  class Javascript
    has n, :layouts, :through => Resource
  end
  
  class Layout
    include DataMapper::Resource

    property :id, Serial
    property :name, String,
              :required => true,
              :length => 255
    property :format, Enum[:none, :erb, :markdown],
              :required => true
    property :body, Text,
              :required => true
    
    has n, :csses, 'UzuUzu::Css', :through => Resource
    has n, :javascripts, 'UzuUzu::Javascript', :through => Resource
    
    def render(options={}, locals={})
      UzuUzu::Controller.current.render_engine(self.body, self.format, options, locals)
    end # render
  end # Layout
  
  if auto_upgrade?
    repository do
      Layout.auto_upgrade!
      JavascriptLayout.auto_upgrade!
      CssLayout.auto_upgrade!
    end
  end
end #UzuUzu
