# coding: utf-8

require 'uzuuzu-cms/model/css'
require 'uzuuzu-cms/model/javascript'
require 'uzuuzu-cms/model/wiki_layout'
require 'uzuuzu-cms/model/wiki_attache'
require 'uzuuzu-cms/model/wiki_entry'

module UzuUzu

  class Css
    has n, :wikis, :through => Resource
  end
  
  class Javascript
    has n, :wikis, :through => Resource
  end
  
  class Wiki
    include DataMapper::Resource

    property :id, Serial
    property :title, String,
              :required => true,
              :length => 255
    
    has n, :wiki_layouts
    has n, :wiki_entries
    has n, :csses, :through => Resource
    has n, :javascripts, :through => Resource
  end
  
  if auto_upgrade?
    repository do
      Wiki.auto_upgrade!
      WikiJavascript.auto_upgrade!
      WikiCss.auto_upgrade!
      WikiLayout.auto_upgrade!
      WikiEntry.auto_upgrade!
      WikiAttache.auto_upgrade!
    end
  end
end
